Loading...
Searching...
No Matches
receiver_options

Options for creating a receiver. More...

`#include <receiver_options.hpp>`

## Public Member Functions

| receiver_options ()
| Create an empty set of options.
| receiver_options (const receiver_options &)
| Copy options.
receiver_options & | operator= (const receiver_options &)
| Copy options.
void | update (const receiver_options &other)
| Merge with another option set.
receiver_options & | handler (class messaging_handler &)
| Set a messaging_handler for receiver events only.
receiver_options & | delivery_mode (delivery_mode)
| Set the delivery mode on the receiver.
receiver_options & | auto_accept (bool)
| Enable or disable automatic acceptance of messages that aren't otherwise released, rejected, or modified.
receiver_options & | auto_settle (bool)
| Deprecated - Applicable only to sender, not receiver.
receiver_options & | source (source_options &)
| Options for the source node of the receiver.
receiver_options & | target (target_options &)
| Options for the target node of the receiver.
receiver_options & | credit_window (int count)
| Automatically replenish credit for flow control up to count messages.
receiver_options & | name (const std::string &name)
| Set the link name. If not set a unique name is generated.
receiver_options & | properties (const std::map< symbol, value > &)
| Unsettled API - Link properties.

## Detailed Description

Options for creating a receiver.

Options can be "chained" like this:

l = container.create_receiver(url, receiver_options().handler(h).auto_accept(true));
proton::container
A top-level container of connections, sessions, and links.
Definition container.hpp:49
proton::receiver_options::handler
receiver_options & handler(class messaging_handler &)
Set a messaging_handler for receiver events only.
proton::receiver_options::auto_accept
receiver_options & auto_accept(bool)
Enable or disable automatic acceptance of messages that aren't otherwise released,...
proton::receiver_options::receiver_options
receiver_options()
Create an empty set of options.
proton::url
Deprecated - Use a third-party URL library.
Definition url.hpp:66

You can also create an options object with common settings and use it as a base for different connections that have mostly the same settings:

receiver_options opts;
opts.auto_accept(true);
c2 = container.open_receiver(url2, opts.handler(h2));
proton::container::open_receiver
returned< receiver > open_receiver(const std::string &addr_url)
Open a connection and receiver for addr_url.

Normal value semantics: copy or assign creates a separate copy of the options.

Examples
  client.cpp, and service_bus.cpp.

## Member Function Documentation

## handler()

receiver_options & handler | ( | class messaging_handler & |  | ) |

Set a messaging_handler for receiver events only.

The handler is no longer in use when messaging_handler::on_receiver_close() is called.

## delivery_mode()

receiver_options & delivery_mode | ( | delivery_mode |  | ) |

Set the delivery mode on the receiver.

The default is delivery_mode::AT_LEAST_ONCE.

## auto_accept()

receiver_options & auto_accept | ( | bool |  | ) |

Enable or disable automatic acceptance of messages that aren't otherwise released, rejected, or modified.

It is enabled by default.

## credit_window()

receiver_options & credit_window | ( | int | count | ) |

Automatically replenish credit for flow control up to count messages.

The default is 10. Set to zero to disable automatic replenishment.

The documentation for this class was generated from the following file:

- proton/receiver_options.hpp